#include <iostream>
#include <iomanip>
#include <vector>
#include <climits>
using namespace std;

struct Computer {
    int     computerNumber;
    int     rentedByCustomer;
    string  operatingSystem;
    int     numberOfInventory;
    double  hourPrice;
    int     numberOfRents;
    double  moneyEarned;
};

typedef vector<Computer> Computers;

struct Customer {
    string  name;
    string  address;
    string  personalCode;
    double  moneyEarned;
    int     age;
};

typedef vector<Customer> Customers;

void printMenu      ();
void printComputersBooked  (const Computers&  computers); // booked
void printComputersFree    (const Computers&  computers);// free
void printCustomers        (const Customers&  customers, const Computers&  computers);
void printCustomers1       (const Customers&  customers);
void addComputer           (      Computers&  computers);
void addCustomer           (      Customers&  customers);
void rentComputer          (      Computers&  computers, Customers& customers);
void releaseComputer       (      Computers&  computers);
void mostIncome            (      Computers&  computers);
void mostRented            (      Computers&  computers);

int main () {
    Computers   computers;
    Customers   customers;
    for (;;) {
        cout << "\n----------------------------------------\n";
        cout << "(m - rodyti meniu) > ";
        string command;
        cin >> command;
             if (command == "0") return 0;
        else if (command == "m") printMenu          ();
        else if (command == "1") printComputersBooked   (computers);
        else if (command == "2") printComputersFree     (computers); 
        else if (command == "3") addComputer            (computers);
        else if (command == "4") rentComputer           (computers, customers);
        else if (command == "5") releaseComputer        (computers);
        else if (command == "6") printCustomers         (customers, computers);
        else if (command == "7") addCustomer            (customers);
        else if (command == "8") mostIncome             (computers);
        else if (command == "9") mostRented             (computers);
        else cout << endl << "Ivesta neteisinga komanda..." << endl;
    }
}

void printMenu () {
    cout << endl
         << "E-kavine:" << endl
         << " 1 - rodyti uzimtus kompiuterius"           << endl
         << " 2 - rodyti laisvus kompiuterius"           << endl
         << " 3 - prideti nauja kompiuteri"              << endl
         << " 4 - isnuomuoti klientui"                   << endl
         << " 5 - atlaisvinti kompiuteri"                << endl
         << " 6 - spausdinti klientus"                   << endl
         << " 7 - prideti nauja klienta"                 << endl
         << " 8 - rodyti daugiausiai uzdirbusi"          << endl
         << " 9 - rodyti daugiausiai naudojama"          << endl
         << " 0 - baigti darba"   <<endl;
}

void printComputersBooked   (const Computers&    computers) {
    int booked = 0;
    for (int i = 0; i < computers.size(); i++) {
        if (computers[i].rentedByCustomer != 0) {
            booked += 1;                                  
        }    
    }
    cout << "Uzimtu kompiuteriu kiekis: " << booked << endl;
    for  (int i = 0;  i < computers.size();      i++) {
         if (computers[i].rentedByCustomer != 0) {
             cout << (i+1)
                 << "\t"  << computers[i].operatingSystem
                 << " ("  << computers[i].hourPrice << "Lt)"
                 << "\t"  << computers[i].computerNumber
                 << "\t"  << computers[i].numberOfInventory
                 << "\t"  << computers[i].numberOfRents
                 << "\t(" << computers[i].moneyEarned << "Lt)"
                 << endl;
         }
    }
}

void printComputersFree (const Computers& computers) {
    int free = 0;
    for (int i = 0; i < computers.size(); i++) {
        if (computers[i].rentedByCustomer == 0) {
            free += 1;                                  
        }    
    }
    cout << "Laisvu kompiuteriu kiekis: " << free << endl;
    for (int i = 0; i < computers.size(); i++) {
        if (computers[i].rentedByCustomer == 0) {
            cout << (i+1)
            << "\t" << computers[i].operatingSystem
            << " (" << computers[i].hourPrice << "Lt)"
            << "\t" << computers[i].computerNumber
            << "\t" << computers[i].numberOfInventory
            << "\t" << computers[i].numberOfRents
            << "\t("<< computers[i].moneyEarned << "Lt)"
            << endl;                                   
        }
    }   
}


void printCustomers   (const Customers& customers, const Computers& computers) {
     int booked = 0;
     cout << "Klientu kiekis: " << customers.size() << endl;
     for  (int i = 0;  i < customers.size(); i++) {
          cout << (i+1)
               << ". ("   << customers[i].moneyEarned << "Lt)"
               << "\t"    << customers[i].name
               << " ("    << customers[i].address << ")"
               << " ("    << customers[i].age << "metu)"
               << "(a.s." << customers[i].personalCode << ")"
               << endl;
     }
     cout << "|Jei nori pamatyti kliento siuo metu isnuomotus|" << endl
          << "|kompiuretius ivesk kliento eiles nr, jei ne   |" << endl
          << "|              iveskite 0                      |" << endl;
     int number;
     cin >> number;
     if (number == 0) {
         return;           
     }
     if (number != 0) {
         cout << "Kliento isnuomotu kompiuteriu nr: ";
         for (int i = 0; i < computers.size(); i++) {
             if (number == computers[i].rentedByCustomer){
                 cout << computers[i].computerNumber << " ";             
             }    
         }            
     }    
}

void printCustomers1   (const Customers& customers) {
    cout << "Klientu kiekis: " << customers.size() << endl;
    for  (int i = 0;  i < customers.size(); i++) {
        cout << (i+1)
             << ". ("   << customers[i].moneyEarned << "Lt)"
             << "\t"    << customers[i].name
             << " ("    << customers[i].address << ")"
             << " ("    << customers[i].age << "metu)"
             << "(a.s." << customers[i].personalCode << ")"
             << endl;
    }
}

void addComputer (Computers& computers) {
    cin.ignore (INT_MAX, '\n'); 
    Computer computer;
    cout << "Iveskite nauja kompiuteri: " << endl;
    cout << "    kompiuterio nr      : "; cin >> computer.computerNumber;    
    cout << "    operacine sistema (Windows/Linux/Mac): "; cin >> computer.operatingSystem;     cout << "    inventorizacijos nr : "; cin >> computer.numberOfInventory;
    cout << "    kaina valandai      : "; cin >> computer.hourPrice;
    computer.rentedByCustomer = 0;
    computer.moneyEarned      = 0;
    computer.numberOfRents     = 0;
    computers.push_back(computer);
}

void addCustomer (Customers& customers) {
    cin.ignore (INT_MAX, '\n');
    Customer customer;
    cout << "Iveskite nauja klienta:" << endl;
    cout << "    vardas    : "; getline(cin, customer.name);
    cout << "    adresas   : "; getline(cin, customer.address);
    cout << "    asm. kodas: "; cin >> customer.personalCode;
    cout << "    amzius    : "; cin >> customer.age;
    customer.moneyEarned = 0;
    customers.push_back(customer);
}

void rentComputer (Computers& computers, Customers& customers)  {
    int computerNo = 0;
    printComputersFree (computers);
    cout << "Iveskite kompiuterio nr: ";
    cin  >> computerNo;
    if (computerNo <= 0 || computerNo > computers.size() ) {
        cout << "KLAIDA: nera kompiuterio ivestu numeriu...";
        return;
    }
    if (computers[computerNo-1].rentedByCustomer != 0) {
        cout << "KLAIDA: kompiuteris siuo metu uzimtas...";
        return;
    }
    int customerNo = 0;
    printCustomers1 (customers);
    cout << "Pasirinkite kliento eiles nr: ";
    cin >> customerNo;
    if (customerNo  <= 0 || customerNo > customers.size() ) {
        cout << "KLAIDA: nera kliento su tokiu eiles nr...";
        return;
    }
    int hourCount;
    cout << "Keliom valandom nuomuosime     : ";
    cin >> hourCount;
    computers[computerNo-1].rentedByCustomer = customerNo;
    double moneyEarned = hourCount * computers[computerNo-1].hourPrice;
    computers[computerNo-1].moneyEarned     += moneyEarned;
    customers[customerNo-1].moneyEarned     += moneyEarned;
    computers[computerNo-1].numberOfRents   += 1;
}

void releaseComputer     (Computers&   computers)  {
    int computerNo = 0;
    printComputersBooked (computers);
    cout << "Iveskit compiuterio eiles nr, kuri norite atlaisvinti: ";
    cin  >> computerNo;
    if (computerNo <= 0 || computerNo > computers.size() ) {
        cout << "KLAIDA: nera uzimto kompiuterio su ivestu nr...";
        return;
    }
    computers[computerNo-1].rentedByCustomer = 0;
}

void mostIncome (Computers& computers) {
    if (computers.size() == 0) {
        cout << "Jus neturite ivestu kompiuteriu!" << endl;
        return;
    }
    if (computers.size() == 1) {
        cout << "Kolkas pas jus yra tik 1 kompiuteris, jis jums uzdirbo " 
             << computers[0].moneyEarned << " Lt." << endl;
    }
    double mostIncomeComputer;
    if (computers.size() > 1) {
        mostIncomeComputer = computers[0].moneyEarned;
        for (int i = 1; i <= computers.size(); i++) {
            if (mostIncomeComputer < computers[i].moneyEarned) {
                mostIncomeComputer = computers[i].moneyEarned;
            }
        }
        cout << "Daugiausiai jums uzdirbo";
        for (int i = 0; i < computers.size(); i++) {
            if (mostIncomeComputer == computers[i].moneyEarned) {
                cout << " " << computers[i].computerNumber;                    
            }    
        }
        cout << " kompiuteris(iai)." << endl;
    }
}


void mostRented (Computers& computers) {
    if (computers.size() == 0) {
        cout << "Jus neturite ivestu kompiuteriu!" << endl;
        return;
    }
    if (computers.size() == 1) {
        cout << "Kolkas pas jus yra tik 1 kompiuteris, jis buvo isnuomotas " 
             << computers[0].numberOfRents << " kartus(u)." << endl;
    }
    int mostTimesRentedComputer;
    if (computers.size() > 1) {
        mostTimesRentedComputer = computers[0].numberOfRents;
        for (int i = 1; i <= computers.size(); i++) {
            if (mostTimesRentedComputer < computers[i].numberOfRents) {
                mostTimesRentedComputer = computers[i].numberOfRents;
            }
        }
        cout << "Daugiausiai kartu nuomotas(i) yra";
        for (int i = 0; i < computers.size(); i++) {
            if (mostTimesRentedComputer == computers[i].numberOfRents) {
                cout << " " << computers[i].computerNumber;
            }    
        }
        cout << " kompiuteris(iai)." << endl;    
    }
}
